//


//,   ,    !!
//-   


#include "version.h" //    
//   :
#include <jka/game/q_shared.h>
#include <jka/game/g_local.h>
#include <jassapi.h> //,  
//#include <windows.h>

#define TEMP_LEN 32
#define strcasecmp stricmp

//  info_player_start
pluginres_t* g_result = NULL;
//  
plugininfo_t g_plugininfo = {
	"Academy5",					// 
	Academy5_version,			//
	"Adds respawns and deletes npc on Academy5.bsp",				//
	Academy5_Builder,			//
	"http://www.jass.ucoz.net/",	//
	1,								//    
	1,								//        
	1,								//        
	JASS_PIFV_MAJOR,				//  (  jassapi.h)
	JASS_PIFV_MINOR
};
eng_syscall_t g_syscall = NULL;
mod_vmMain_t g_vmMain = NULL;
pluginfuncs_t* g_pluginfuncs = NULL;
//info_player_start			//  
//info_player_start_blue	//
//info_player_start_red		//
//info_player_intermission	//
gentity_t *ent;
//ent->s.origin
//ent->s.angles
int dw_allowNPC=1;
bool isAcademy=false;

//  ,   ,  
//   .   
//    
#define	FOFS(x) ((int)&(((gentity_t *)0)->x))
#ifdef WIN32
int adr_G_Spawn=0x200B0B70				//gentity_t *G_Spawn( void )
	,adr_trap_LinkEntity=0x200A6260		//vdoid trap_LinkEntity( gentity_t *ent )
	,adr_trap_UnlinkEntity=0x200A6280	//trap_UnlinkEntity( gentity_t *ent )
	,adr_G_FreeEntity=0x200B0DB0		//void G_FreeEntity( gentity_t *ed )
	,adr_G_Find=0x200B01F0				//gentity_t *G_Find (gentity_t *from, int fieldofs, const char *match)
	//,adr_SP_misc_faller=0x20096AC0		//void SP_misc_faller(gentity_t *ent)
	//,adr_SP_NPC_spawner=0x20030210
	//,adr_G_DoesMapSupportGametype=0x200747A0
	,adr_level_voteString=0x207EEB50
	,adr_level_voteDisplayString=0x207EEF50
	,adr_level_voteTime=0x207EF350
	,adr_level_time=0x207EEA80
	,adr_level_voteYes=0x207EF358
	,adr_level_voteNo=0x207EF35C
	,adr_level_maxclients=0x207EEA78
	,adr_level_clients=0x207EEA60

#else
#include <dlfcn.h>

char defaultlib[]="jass_jampgamei386.so";
char defaultdir[]="base";
size_t offset=0;
int adr_G_Spawn=0x0016DB44				//gentity_t *G_Spawn( void )
	,adr_trap_LinkEntity=0x0015E7A4		//void trap_LinkEntity( gentity_t *ent )
	,adr_trap_UnlinkEntity=0x0015E7C4	//trap_UnlinkEntity( gentity_t *ent )
	,adr_G_FreeEntity=0x0016DE44		//void G_FreeEntity( gentity_t *ed )
	,adr_G_Find=0x0016CEC4				//gentity_t *G_Find (gentity_t *from, int fieldofs, const char *match)
	//,adr_SP_misc_faller=0x0014A284	//void SP_misc_faller(gentity_t *ent)
	//,adr_SP_NPC_spawner=0x000C7244
	//,adr_G_DoesMapSupportGametype=0x001208E4
	//,adr_level=0x0068A3A0
	,adr_level_voteString=0x0068A3A0+0x0F0
	,adr_level_voteDisplayString=0x0068A3A0+0x4F0
	,adr_level_voteTime=0x0068A3A0+0x8F0
	,adr_level_time=0x0068A3A0+0x20
	,adr_level_voteYes=0x0068A3A0+0x8F8
	,adr_level_voteNo=0x0068A3A0+0x8FC
	,adr_level_maxclients=0x0068A3A0+0x18
	,adr_level_clients=0x0068A3A0
	,adr_vmMain=0x00085684
	,adr_dllEntry=0x0015E104

#endif
	;

float spawnpoints[33][5]={
//pitch -90= , 90= .   
//yaw 0-360
//roll  
//		x			y			z			pitch		yaw			roll
	//red
	{	-1180.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1270.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1360.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1450.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1540.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1630.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	//blue
	{	-1180.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1270.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1360.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1450.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1540.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1630.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	//spectator
	{	-1400.0f,	300.0f,		1000.0f,	35.0f,		270.0f	},
	//free
	{	-1630.0f,	90.0f,		700.0f,		0.0f,		0.0f	},
	{	-2000.0f,	-250.0f,	700.0f,		0.0f,		0.0f	},
	{	-2000.0f,	-650.0f,	700.0f,		0.0f,		0.0f	},
	{	-1700.0f,	-1100.0f,	700.0f,		0.0f,		0.0f	},
	{	-1100.0f,	-1100.0f,	700.0f,		0.0f,		180.0f	},
	{	-1200.0f,	90.0f,		700.0f,		0.0f,		180.0f	},
	{	-800.0f,	-250.0f,	700.0f,		0.0f,		180.0f	},
	{	-800.0f,	-650.0f,	700.0f,		0.0f,		180.0f	},
	//free in red
	{	-1180.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1270.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1360.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1450.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1540.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	{	-1630.0f,	300.0f,		750.0f,		0.0f,		270.0f	},
	//free in blue
	{	-1180.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1270.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1360.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1450.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1540.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
	{	-1630.0f,	-1500.0f,	750.0f,		0.0f,		90.0f	},
};


char *Info_ValueForKey( const char *s, const char *key ) {
	char	pkey[BIG_INFO_KEY];
	static	char value[2][BIG_INFO_VALUE];	// use two buffers so compares
											// work without stomping on each other
	static	int	valueindex = 0;
	char	*o;

	if ( !s || !key ) {
		return "";
	}

	if ( strlen( s ) >= BIG_INFO_STRING ) {
		return "";
	}

	valueindex ^= 1;
	if (*s == '\\')
		s++;
	while (1)
	{
		o = pkey;
		while (*s != '\\')
		{
			if (!*s)
				return "";
			*o++ = *s++;
		}
		*o = 0;
		s++;

		o = value[valueindex];

		while (*s != '\\' && *s)
		{
			*o++ = *s++;
		}
		*o = 0;

		if (!strcasecmp (key, pkey) )
			return value[valueindex];

		if (!*s)
			break;
		s++;
	}

	return "";
}

//  ,  
// pinfo -    g_plugininfo ( )
C_DLLEXPORT void JASS_Query(plugininfo_t** pinfo) {
	JASS_GIVE_PINFO();
}

// ,  
// ,    ,  
// engfunc -    syscall 
// modfunc -    vmMain 
// presult -     
// iscmd -  : 0 =    jass.ini, 1 =    "jass load"
C_DLLEXPORT int JASS_Attach(eng_syscall_t engfunc, mod_vmMain_t modfunc, pluginres_t* presult, pluginfuncs_t* pluginfuncs, int iscmd) {
	JASS_SAVE_VARS();
	iscmd = 0;

	return 1;
	//return 0; - 
}

//int g_allowNPCint=0;
//  ,  
// ,    ,  
// - iscmd  ; 0 =         "jass force_unload", 1 =   "jass unload"
C_DLLEXPORT void JASS_Detach(int iscmd) {
	if(isAcademy){
		g_syscall(G_CVAR_SET,"g_allowNPC",JASS_VARARGS("%i",dw_allowNPC));
	}
	iscmd = 0;
}

char info_player_start[]="info_player_deathmatch";
char info_player_start_blue[]="info_player_start_blue";
char info_player_start_red[]="info_player_start_red";
char info_player_intermission[]="info_player_intermission";


#ifdef WIN32
//bool spawns_add=1;
//ent->s.origin
//ent->s.angles
//      vmMain  (..  - )
// ,     ,
// ..  cmd==GAME_SHUTDOWN,  
C_DLLEXPORT int JASS_vmMain(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11) {

//  GAME_ICARUS_PLAYSOUND!
//    . ,     10  .
	if (cmd==GAME_INIT){
		if(!strcasecmp(JASS_GETSTRCVAR("mapname"),"academy5")){
			isAcademy=true;
			//g_syscall(G_CVAR_VARIABLE_STRING_BUFFER,"g_allowNPC",sz_allowNPC,sizeof(g_allowNPC));
			dw_allowNPC = JASS_GETINTCVAR("g_allowNPC");
			g_syscall(G_CVAR_SET,"g_allowNPC","0");
		}
	}
	if ( cmd==GAME_CLIENT_COMMAND ) {
		int argc = g_syscall( G_ARGC );
		char temp [TEMP_LEN];
		if (argc==3){
			g_syscall( G_ARGV, 0, temp, TEMP_LEN );
			if (!strcasecmp (temp,"callvote")){
				g_syscall( G_ARGV, 1, temp, TEMP_LEN );
				if (!strcasecmp (temp,"map")){
					g_syscall( G_ARGV, 2, temp, TEMP_LEN );
					if (!strcasecmp (temp,"academy5")){
						char * s= (char*) JASS_GETSTRCVAR("nextmap");

						if (*s) {
							sprintf( (char*)adr_level_voteString, "map academy5; set nextmap \"%s\"", s );
						} else {
							sprintf( (char*)adr_level_voteString, "map academy5" );
						}
						sprintf( (char*)adr_level_voteDisplayString, "map academy5 by ^4vJL^7~^5Zlyden^2'");
						char userinfo[1024];
						g_syscall( G_GET_USERINFO, arg0, userinfo, sizeof(userinfo) );
						g_syscall( G_SEND_SERVER_COMMAND, -1, JASS_VARARGS("print \"%s^7 @@@PLCALLEDVOTE\n\"", Info_ValueForKey(userinfo,"name") ) );

						//level.voteTime = level.time;
						//level.voteYes = 1;
						//level.voteNo = 0;
						*(int*)(adr_level_voteTime) = *(int*)adr_level_time;
						*(int*)(adr_level_voteYes) = 1;
						*(int*)(adr_level_voteNo) = 0;

						for ( int i = 0 ; i < *(int*)adr_level_maxclients ; ++i ) {
							if (i!=arg0)
								((gclient_s*)adr_level_clients)[i].mGameFlags &= ~PSG_VOTED;
							else
								((gclient_s*)adr_level_clients)[i].mGameFlags |= PSG_VOTED;
						}

						g_syscall( G_SET_CONFIGSTRING, CS_VOTE_TIME, JASS_VARARGS("%i", *(int*)adr_level_voteTime ) );
						g_syscall( G_SET_CONFIGSTRING, CS_VOTE_STRING, (char*)adr_level_voteDisplayString );
						g_syscall( G_SET_CONFIGSTRING, CS_VOTE_YES, JASS_VARARGS("%i", *(int*)adr_level_voteYes ) );
						g_syscall( G_SET_CONFIGSTRING, CS_VOTE_NO, JASS_VARARGS("%i", *(int*)adr_level_voteNo ) );
						JASS_RET_SUPERCEDE(1);
					}
				}
			}
		}

	}


	JASS_RET_IGNORED(1); //  
}
//      vmMain  (..  - )
// ,     ,
// ..  cmd==GAME_INIT,  
C_DLLEXPORT int JASS_vmMain_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11) {
	//g_syscall(G_PRINT, JASS_VARARGS("vmMain_Post(%s)\n", JASS_MODMSGNAME(cmd)));
	if (cmd==GAME_INIT){

		char * temp=(char*)JASS_GETSTRCVAR("mapname");

		if ( !strcasecmp(temp,"academy5") ){
			//g_allowNPCint=JASS_GETINTCVAR("g_allowNPC");
			//g_syscall(G_CVAR_SET,"g_allowNPC","0");
			//    NPC_Spawner, NPC_Kyle  NPC_Luke
			//    ,   .
			/* *(int*)0x2010C790=0;
			*(int*)0x2010C778=0;
			*(int*)0x2010C768=0;*/

			// , 33 
			for (int i=0;i<33;++i){
				ent=((gentity_t *( __cdecl* )( void ))adr_G_Spawn)();
				// 6 ,  6 ,  1    
				if(i<6)
					ent->classname=info_player_start_red;
				else if(i<12)
					ent->classname=info_player_start_blue;
				else if(i<13)
					ent->classname=info_player_intermission;
				else
					ent->classname=info_player_start;

				VectorSet(ent->s.origin, spawnpoints[i][0],spawnpoints[i][1],spawnpoints[i][2]);
				ent->s.angles[0]=spawnpoints[i][3];
				ent->s.angles[1]=spawnpoints[i][4];
				//((void ( __cdecl* )( gentity_t *))adr_trap_LinkEntity)( ent );
			}

			//WriteProcessMemory(GetCurrentProcess(), (void*)0x2010C76C,
			//	(void*)&hook_SP_NPC_spawner, 4, 0);

			//
			// 
			ent=NULL;
			do{
				ent=((gentity_t * ( __cdecl* )( gentity_t *, int, const char* ))adr_G_Find)( ent, FOFS(classname), "NPC" );
				if(ent){
					//((void ( __cdecl* )( gentity_t *))adr_trap_UnlinkEntity)( ent );
					((void ( __cdecl* )( gentity_t *))adr_G_FreeEntity)( ent );
				}
			}while(ent);
		}
	}
	JASS_RET_IGNORED(1);
}
#else
C_DLLEXPORT int JASS_vmMain(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11) {

	if (cmd==GAME_INIT){
		if(!strcasecmp(JASS_GETSTRCVAR("mapname"),"academy5")){
			isAcademy=true;
			//g_syscall(G_CVAR_VARIABLE_STRING_BUFFER,"g_allowNPC",sz_allowNPC,sizeof(g_allowNPC));
			dw_allowNPC = JASS_GETINTCVAR("g_allowNPC");
			g_syscall(G_CVAR_SET,"g_allowNPC","0");
		}
	}
	if ( cmd==GAME_CLIENT_COMMAND && offset ) {
		int argc = g_syscall( G_ARGC );
		char temp [TEMP_LEN];
		if (argc==3 && offset){
			g_syscall( G_ARGV, 0, temp, TEMP_LEN );
			if (!strcasecmp (temp,"callvote")){
				g_syscall( G_ARGV, 1, temp, TEMP_LEN );
				if (!strcasecmp (temp,"map")){
					g_syscall( G_ARGV, 2, temp, TEMP_LEN );
					if (!strcasecmp (temp,"academy5")){
						char * s= (char*) JASS_GETSTRCVAR("nextmap");

						if (*s) {
							sprintf( (char*)(offset+adr_level_voteString), "map academy5; set nextmap \"%s\"", s );
						} else {
							sprintf( (char*)(offset+adr_level_voteString), "map academy5" );
						}
						sprintf( (char*)(offset+adr_level_voteDisplayString), "map academy5 by ^4vJL^7~^5Zlyden^2'");
						char userinfo[1024];
						g_syscall( G_GET_USERINFO, arg0, userinfo, sizeof(userinfo) );
						g_syscall( G_SEND_SERVER_COMMAND, -1, JASS_VARARGS("print \"%s^7 @@@PLCALLEDVOTE\n\"", Info_ValueForKey(userinfo,"name") ) );

						//level.voteTime = level.time;
						//level.voteYes = 1;
						//level.voteNo = 0;
						*(int*)(offset+adr_level_voteTime) = *(int*)(offset+adr_level_time);
						*(int*)(offset+adr_level_voteYes) = 1;
						*(int*)(offset+adr_level_voteNo) = 0;

						for ( int i = 0 ; i < *(int*)(offset+adr_level_maxclients) ; ++i ) {
							if (i!=arg0)
								((gclient_s*)(offset+adr_level_clients))[i].mGameFlags &= ~PSG_VOTED;
							else
								((gclient_s*)(offset+adr_level_clients))[i].mGameFlags |= PSG_VOTED;
						}

						g_syscall( G_SET_CONFIGSTRING, CS_VOTE_TIME, JASS_VARARGS("%i", *(int*)(offset+adr_level_voteTime) ) );
						g_syscall( G_SET_CONFIGSTRING, CS_VOTE_STRING, (char*)(offset+adr_level_voteDisplayString) );
						g_syscall( G_SET_CONFIGSTRING, CS_VOTE_YES, JASS_VARARGS("%i", *(int*)(offset+adr_level_voteYes) ) );
						g_syscall( G_SET_CONFIGSTRING, CS_VOTE_NO, JASS_VARARGS("%i", *(int*)(offset+adr_level_voteNo) ) );
						JASS_RET_SUPERCEDE(1);
					}
				}
			}
		}

	}


	JASS_RET_IGNORED(1); //  
}
//      vmMain  (..  - )
// ,     ,
// ..  cmd==GAME_INIT,  
C_DLLEXPORT int JASS_vmMain_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11) {
	//g_syscall(G_PRINT, JASS_VARARGS("vmMain_Post(%s)\n", JASS_MODMSGNAME(cmd)));
	if (cmd==GAME_INIT){

		g_syscall(G_CVAR_REGISTER,0,"jass_GameLib","jass_jampgamei386.so",CVAR_ARCHIVE);
		char *lib=(char*)JASS_GETSTRCVAR("jass_GameLib");
		if (!lib)
			lib=defaultlib;
		char *dir=(char*)JASS_GETSTRCVAR("fs_game");
		if (!dir)
			dir=defaultdir;
		char * temp=JASS_VARARGS("%s%s/%s",JASS_GETHOMEPATH(),dir,lib);
		void *hSO=dlopen(temp,RTLD_NOW);
		if (!hSO){
			JASS_WRITEJASSLOG(JASS_VARARGS("ACADEMY5: Error: unable to load %s. Wrong lib, uhh?\n",temp));
			JASS_RET_IGNORED(1);
		}
		offset=(size_t)dlsym(hSO,"vmMain");
		if(offset){
			offset-=adr_vmMain;
		}
		else{
			offset=(size_t)dlsym(hSO,"dllEntry");
			if(offset){
				offset-=adr_dllEntry;
			}
			else{
				JASS_WRITEJASSLOG("ACADEMY5: Error: NULL offset. Wrong lib, uhh?\n");
				JASS_RET_IGNORED(1);
			}
		}

		temp=(char*)JASS_GETSTRCVAR("mapname");

		if ( !strcasecmp(temp,"academy5") && offset ){
			// , 33 
			for (int i=0;i<33;++i){
				ent=  ((gentity_t* (*)( ))(offset+adr_G_Spawn))();
				// 6 ,  6 ,  1    
				if(i<6)
					ent->classname=info_player_start_red;
				else if(i<12)
					ent->classname=info_player_start_blue;
				else if(i<13)
					ent->classname=info_player_intermission;
				else
					ent->classname=info_player_start;

				VectorSet(ent->s.origin, spawnpoints[i][0],spawnpoints[i][1],spawnpoints[i][2]);
				ent->s.angles[0]=spawnpoints[i][3];
				ent->s.angles[1]=spawnpoints[i][4];
				//( ( void (*)( gentity_t *) )offset+adr_trap_LinkEntity)( ent );
			}

			//WriteProcessMemory(GetCurrentProcess(), (void*)0x2010C76C,
			//	(void*)&hook_SP_NPC_spawner, 4, 0);

			//
			// 
			ent=NULL;
			do{
				ent=((gentity_t * (*)( gentity_t *, int, const char* ))offset+adr_G_Find)( ent, FOFS(classname), "NPC" );
				if(ent){
					//((void (*)( gentity_t *))offset+adr_trap_UnlinkEntity)( ent );
					((void (*)( gentity_t *))offset+adr_G_FreeEntity)( ent );
				}
			}while(ent);
		}
	}
	JASS_RET_IGNORED(1);
}

#endif

//      syscall  (..  - )
C_DLLEXPORT int JASS_syscall(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12) {
	/*
	if (cmd == G_PRINT) {
		JASS_RET_SUPERCEDE(1);
	}
*/
	//g_syscall(G_PRINT, JASS_VARARGS("syscall(%s)\n", JASS_ENGMSGNAME(cmd)));

	JASS_RET_IGNORED(1);
}
//      syscall  (..  - )
C_DLLEXPORT int JASS_syscall_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12) {
	//g_syscall(G_PRINT, JASS_VARARGS("syscall_Post(%s)\n", JASS_ENGMSGNAME(cmd)));
	JASS_RET_IGNORED(1);
}
